package com.ruoyi.bst.hardwareVersion.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.bst.hardwareVersion.domain.HardwareVersion;
import com.ruoyi.bst.hardwareVersion.domain.HardwareVersionQuery;
import com.ruoyi.bst.hardwareVersion.domain.HardwareVersionVO;
import com.ruoyi.bst.hardwareVersion.domain.vo.HardwareVersionNameVO;

/**
 * 硬件版本Mapper接口
 *
 * @author ruoyi
 * @date 2025-04-07
 */
public interface HardwareVersionMapper
{
    /**
     * 查询硬件版本
     *
     * @param id 硬件版本主键
     * @return 硬件版本
     */
    HardwareVersionVO selectHardwareVersionById(Long id);

    /**
     * 查询硬件版本列表
     *
     * @param query 硬件版本
     * @return 硬件版本集合
     */
    List<HardwareVersionVO> selectHardwareVersionList(@Param("query")HardwareVersionQuery query);

    /**
     * 新增硬件版本
     *
     * @param hardwareVersion 硬件版本
     * @return 结果
     */
    int insertHardwareVersion(HardwareVersion hardwareVersion);


    /**
     * 修改硬件版本
     *
     * @param hardwareVersion 硬件版本
     * @return 结果
     */
    public int updateHardwareVersion(@Param("data") HardwareVersion hardwareVersion);

    /**
     * 删除硬件版本
     *
     * @param id 硬件版本主键
     * @return 结果
     */
    int deleteHardwareVersionById(Long id);

    /**
     * 批量删除硬件版本
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteHardwareVersionByIds(Long[] ids);

    int selectNum(@Param("query") HardwareVersionVO hardwareVersion,@Param("condition") String condition);


    /**
     * 已绑定版本数
     */
    int countBoundNum(Long id);

    /**
     * 未绑定版本数
     */
    int countUnBoundNum(Long id);

    List<HardwareVersionVO> selectBoundCount(HardwareVersionQuery query);

    List<HardwareVersionVO> selectUnBoundCount(HardwareVersionQuery query);
    /**
     * 查询硬件版本名称
     */
    List<HardwareVersionNameVO> selectNameList(@Param("query") HardwareVersionQuery query);

}
